#version 150

// This came from some tutorial, mentioning some drivers required this to function
//   properly but did not delve into why. 
precision highp float;

in  vec3 fragmentNormal;
in  vec4 fragmentColor;
in  vec2 fragmentTextureUV;

out vec4 finalFragColor;

// diffuseTexture is a 2D texture sampler for diffuse texture.
uniform sampler2D diffuseTexture;
uniform vec4 ambientLightColor = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 sunLightColor = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 sunLightDirection = vec4(-0.447766751, 0.373415232, 0.812444329, 0.422158539);  //Expected to be a unit vector and in world space already.
uniform vec4 materialColor = vec4(1.0, 1.0, 1.0, 1.0);

void main(void)
{
	vec4 texturedFragmentColor = fragmentColor * materialColor;

	float nDotL = clamp(dot(fragmentNormal, vec3(sunLightDirection)), 0.0, 1.0);
	
	vec3 diffuseLighting = (nDotL * vec3(texturedFragmentColor) * vec3(sunLightColor));
	vec3 ambientLighting = vec3(ambientLightColor) * vec3(texturedFragmentColor);
	vec3 finalColor = ambientLighting + diffuseLighting;

	//TODO: TIM: Check if this is how we should handle alpha...
	//finalFragColor = vec4(pow(finalColor, vec3(1.0 / 2.2, 1.0 / 2.2, 1.0 / 2.2)), 1.0);
	finalFragColor = vec4(pow(finalColor, vec3(1.0 / 2.2, 1.0 / 2.2, 1.0 / 2.2)), texturedFragmentColor.a);

	if (finalFragColor.a < 0.25)
	{
		discard;
	}	
}
