#version 100

// vertexPosition was bound to attribute index 0 and vertexColor was bound to attribute index 1
attribute vec3 vertexPosition;
attribute vec3 vertexNormal;
attribute vec4 vertexColor;
attribute vec2 vertexTextureUV;
 
// Our outputs the next shader (fragment) in the chain
varying vec3 fragmentNormal;
varying vec4 fragmentColor;
varying vec2 fragmentTextureUV;

uniform mat4 mvpMatrix;
uniform mat4 modelViewMatrix;
uniform mat4 modelMatrix;

void main(void)
{
	gl_Position = vec4(vertexPosition, 1.0) * mvpMatrix;

	fragmentNormal = vec3(normalize(vec4(vertexNormal, 0.0) * modelMatrix));

	fragmentColor = vertexColor;
	fragmentTextureUV = vertexTextureUV;
}
